<template>
	<el-row class="marginTop20 notice">
		<el-row class="flexVcenter">
			<div class="marginRight10 f14 c9696A0" style="display:inline-block;">日期选择</div>
			<el-col :span="16">
				<el-date-picker
					v-model="selectDate"
					type="daterange"
					size="small"
					range-separator="至"
					start-placeholder="开始日期"
					end-placeholder="结束日期"
					value-format="yyyyMMdd"
				></el-date-picker>
			</el-col>
		</el-row>
		<el-row class="flexVcenter marginTop20">
			<div class="marginRight10 f14 c9696A0" style="display:inline-block;">消息类型</div>
			<el-col :span="20">
				<el-checkbox
					v-for="(check,index) in checkBoxs"
					v-model="check.select"
					:key="index"
				>{{check.text}}</el-checkbox>
			</el-col>
		</el-row>
		<ootecoTable class="marginTop30" ref="noticeTable" :conf="tableConf" :url="'message/list'"></ootecoTable>
	</el-row>
</template>

<script>
import ootecoTable from '@com/ooteco_table'
import taskAndNotice from './data_conf/taskAndNotice.js'
export default {
	mixins: [$mixin],
	components: { ootecoTable },
	data() {
		return Object.assign({}, taskAndNotice, {
			selectDate: '',
			multipleSelection: []
		})
	},
	computed: {
		checkBoxSelect() {
			let type_arr = this.checkBoxs.filter(item => {
				return item.select
			})
			type_arr = type_arr.map(item => {
				return item.val
			})
			return type_arr.join(',')
		}
	},
	watch: {
		selectDate(val) {
			this.$set(this.tableConf.params, 'startTime', val[0])
			this.$set(this.tableConf.params, 'endTime', val[1])
			if (this.tableConf.params.startTime && this.tableConf.params.endTime) {
				this.$refs.noticeTable.requestData()
			}
		},
		checkBoxSelect(val) {
			this.$set(this.tableConf.params, 'businessType', val)
            this.$set(this.tableConf.params, 'pageNum', 1)
			this.$refs.noticeTable.requestData()
		}
	},
	methods: {
		initListen() {
			this.listen('handleSelectionChange', val => {
				this.multipleSelection = val
			})
			this.listen('markNotice', () => {
				let arr = this.multipleSelection.map(item => {
					return item.id
				})
				if (!arr.length) {
					this.alert('请先选择一条数据')
					return false
				}
				this.$http
					.post({
						url: 'message/read',
						params: {
							ids: arr.join(',')
						}
					})
					.then(
						({ data }) => {
							this.alert('标记成功', () => {
								this.$refs.noticeTable.requestData()
							})
						},
						msg => {
							this.alert(msg)
						}
					)
			})
			this.listen('deleteNotice', () => {
				let arr = this.multipleSelection.map(item => {
					return item.id
				})
                if (!arr.length) {
                    this.alert('请先选择一条数据')
                    return false
                }
				this.$http
					.post({
						url: 'message/delete',
						params: {
							ids: arr.join(',')
						}
					})
					.then(
						({ data }) => {
							this.alert('删除成功', () => {
								this.$refs.noticeTable.requestData()
							})
						},
						msg => {
							this.alert(msg)
						}
					)
			})
		}
	},
	mounted() {
		// this.requesData()
		this.initListen()
	}
}
</script>

<style lang="less">
.controller-container {
	background-color: #ffffff;
}

.notice {
	td {
		border-left: none !important;
		border-right: none !important;
	}
	tr {
		td:nth-child(2) {
			div {
				text-align: center;
			}
		}
	}
	th {
		border-right: none !important;
		border-left: none !important;
	}
	.pagenation {
		display: flex;
		justify-content: flex-end;
		button {
			display: inline-block;
			margin-left: 0.625rem;
			width: 3.75rem;
			height: 1.625rem;
			border-radius: 0.812rem;
			line-height: 1.625rem;
			color: #999;
			text-align: center;
			border: 0.0625rem solid #dddddd;
		}
		button:hover {
			border: 0.0625rem solid #3990e9;
		}
		button:first-child {
			margin-left: 0;
		}
	}
	.el-picker-panel {
		span {
			text-align: center;
		}
		th {
			text-align: center;
		}
	}
}
</style>
